
*      FOUR  ACROSS PRINTOUT OF FULL MEMBERSHIP
*         USING A TEMPORARY SORTED FILE TEMP
*         SORTED ON EITHER
*              MEMBERSHIP NUMBER
*              OR ALPHABETICAL BY OWNER
*  an indexed file can also be used but I find it slower
*    when printing
*                              BY WAYNE DOHERTY
*
*   A DBASE command program to print a condensed membership list
*   in a 4 - up format. Adapted from a 3 - up mailing label
*   program by  Paul W. Heiser
*           in  Mastering DBASE II The Easy Way
*               Prentice-Hall, 1984




ERASE
SET TALK OFF
     SET PRINT ON
?
?'                      MASTER MEMBERSHIP LIST      '

?
?

USE TEMP
    * or the DBASE file to be used
STORE 1 TO TRACKER
   * starts record count
STORE 1 TO LIN
   * starts line count
   * counters must be started at this point

DO WHILE .NOT. EOF
  IF *
     SKIP
      LOOP
        * Skips records marked for deletion. Loop can be omitted.
  ENDIF

    IF TRACKER = 1
       STORE MEMBERSHIP TO MSHIP1
       STORE OWNER TO MOWNER1
       SKIP
         * Stores the desired fields of the first record to temporary
         * storage prior to printing and skips to the next record.

     ELSE
       IF TRACKER = 2
          STORE MEMBERSHIP  TO MSHIP2
          STORE OWNER TO MOWNER2
          SKIP

        ELSE
          IF TRACKER = 3
             STORE MEMBERSHIP TO MSHIP3
             STORE OWNER TO MOWNER3
             SKIP

           ELSE
             IF TRACKER = 4
                STORE MEMBERSHIP TO MSHIP4
                STORE OWNER TO MOWNER4
                SKIP

           ENDIF
        ENDIF
     ENDIF
  ENDIF
    * Ends the reading of records prior to printing.

*  Print step

  STORE TRACKER + 1 TO TRACKER

  IF TRACKER = 2 .AND. EOF
          ? MSHIP1 +;
            MOWNER1
            ?
          RELEASE ALL
    * Prints the line when there is only one record
    * Similar for two and three records
      * The '+;' concatenates the fields in temporary storage
      * so that they print on the same line.

    ELSE
      IF TRACKER =   3 .AND. EOF
         ? MSHIP1 +;
           MOWNER1 +;
           MSHIP3 +;
           MOWNER2
           ?
          RELEASE ALL

        ELSE
          IF TRACKER = 4   .AND. EOF
             ? MSHIP1 +;
               MOWNER1 +;
               MSHIP2 +;
               MOWNER2 +;
               MSHIP3 +;
               MOWNER3
               ?
              RELEASE ALL

           ELSE
             IF TRACKER = 5
                    * a full line
             IF LIN < 58
       * the space between the ? and MSHIP1 is critical
               ? MSHIP1 +;
                 MOWNER1 +;
                 MSHIP2 +;
                 MOWNER2 +;
                 MSHIP3 +;
                 MOWNER3 +;
                 MSHIP4 +;
                 MOWNER4
                RELEASE MSHIP1
                RELEASE MOWNER1
                RELEASE MSHIP2
                RELEASE MOWNER2
                RELEASE MSHIP3
                RELEASE MOWNER3
                RELEASE MSHIP4
                RELEASE MOWNER4
    * Release all causes a hang-up so release the temporary
    * storage variables individually

      STORE 1 TO TRACKER
         * restarts tracker for the first record on the
         * next line.

      STORE LIN + 1 TO LIN
         * adds one to the line count

      ELSE

           IF LIN = 58
              ?
              ?
              ?
              ?
              ?
?'                      MASTER MEMBERSHIP LIST'
              ?
              ?
     * Advances to the second page and prints the heading.

     * Continue the printout.

          ? MSHIP1 +;
            MOWNER1 +;
            MSHIP2 +;
            MOWNER2 +;
            MSHIP3 +;
            MOWNER3 +;
            MSHIP4 +;
            MOWNER4
      RELEASE ALL

        STORE 1 TO TRACKER
        STORE 1 TO LIN
         * starts line 1 on next page
         * continues until EOF condition is met


 * end of print and return to DBASE

             ENDIF
           ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDIF

ENDDO
USE
RELEASE ALL
SET PRINT OFF
RETURN


*  Additional lines can be printed in this format as follows
   *      ?MSHIP1 +;
   *       MOWNER1 +;
   *       MSHIP2 +;
   *        ...  MOWNER4
   * second line
   *      ? MCITY1
   *        MCITY2
   *        ...  MCITY4     etc.

 * If the total characters in a print line is equal to or greater
 * than 80 then the print line will run over. If the number of 
 * characters in the fields is less than a page width the columns 
 * will not be centred. Trailing spaces must be added to the
 * fields to centre the columns as desired. The character count 
 * in a line determines the location of the print.

 






;
            MOWNER1
            ?
          RELEASE ALL
    * Prints the line when there is only one record
    * Similar for two and threee records
      * The '+;' concatenates the fields in temporary storage 
      * so that they print on the sess than a page width the columns 
 * will not be centred. Trailing spaces must be added to the
 * fields to centre the columns as desired. The character count 
 * in a line determines the location of the print.

 






;
            MOWNER1
            ?
          RELEASE ALL
    * Prints the line when there is only one record
    * Similar for two and threee records
      * The '+;' concatenates the fields in temporary storage 
      * so that they print on the s STORE OWNER TO MOWNER4
                SKIP

           ENDIF
        ENDIF
     ENDIF
  ENDIF
    * Ends the reading of records prior to printing.

*  Print step

  STORE TRACKER + 1 TO TRACKER

  IF TRACKER = 2 .AND. EOF
          ? MSHIP1 +;
            MOWNER1
            ?
          RELEASE ALL
    * Prints the line when there is only one record
    * Similar for two and three records
      * The '+;' concaten the fields in temporary storage 
      * so that they print on the s STORE OWNER TO MOWNER4
                SKIP

           ENDIF
        ENDIF
     ENDIF
  ENDIF
    * Ends the reading of records prior to printing.

*  Print step

  STORE TRACKER + 1 TO TRACKER

  IF TRACKER = 2 .AND. EOF
          ? MSHIP1 +;
            MOWNER1
            ?
          RELEASE ALL
    * Prints the line when there is only one record
    * Similar for two and three records
      * The '+;' concaten        ELSE
             IF TRACKER = 5
                    * a full line
             IF LIN < 58
                ?MSHIP1 +;
                 MOWNER1 +;
                 MSHIP2 +;
                 MOWNER2 +;
                 MSHIP3 +;
                 MOWNER3 +;
                 MSHIP4 +;
                 MOWNER4
                RELEASE MSHIP1
                RELEASE MOWNER1
                RELEASE MSHIP2
                RELEASE MOWNER2
                RELEASE MSHIP3
                RELE    RELESE
             IF TRACKER = 5
                    * a full line
             IF LIN < 58
                ?MSHIP1 +;
                 MOWNER1 +;
                 MSHIP2 +;
                 MOWNER2 +;
                 MSHIP3 +;
                 MOWNER3 +;
                 MSHIP4 +;
                 MOWNER4
                RELEASE MSHIP1
                RELEASE MOWNER1
                RELEASE MSHIP2
                RELEASE MOWNER2
                RELEASE MSHIP3
                RELE    RELEERSHIP LIST'
              ?
              ?
     * Advances to the second page and prints the heading.

     * Continue the printout.

          ? MSHIP1 +;
            MOWNER1 +;
            MSHIP2 +;
            MOWNER2 +;
            MSHIP3 +;
            MOWNER3 +;
            MSHIP4 +;
            MOWNER4
      RELEASE ALL

        STORE 1 TO TRACKER
        STORE 1 TO LIN
         * starts line 1 on next page
         * co